| package |
package := Package name: 'SIXX-Tests'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #SixxConstantsTestCase;
	add: #SixxGeneratingTestCase;
	add: #SixxLoadingTestCase;
	add: #SixxMockClassForUnitTest;
	add: #SixxMockEnvelope;
	add: #SixxMockHeader;
	add: #SixxMockSuperClassForUnitTest;
	add: #SixxReadStreamTestCase;
	add: #SixxWriteStreamTestCase;
	add: #SixxXmlParserTestCase;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: 'SIXX-Core';
	add: 'SIXX-ParserAdapter';
	add: '..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

Object subclass: #SixxMockEnvelope
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxMockHeader
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SixxMockSuperClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instVar1 instVar2'!
SixxMockSuperClassForUnitTest subclass: #SixxMockClassForUnitTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'instVar3'!
TestCase subclass: #SixxConstantsTestCase
	instanceVariableNames: 'oldSixxConstants'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SixxGeneratingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SixxLoadingTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SixxReadStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SixxWriteStreamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SixxXmlParserTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SixxMockEnvelope guid: (GUID fromString: '{CA7B9705-1E4B-42A6-8CF2-D3D868B7DDD5}')!
SixxMockEnvelope comment: ''!
!SixxMockEnvelope categoriesForClass!Kernel-Objects! !
!SixxMockEnvelope methodsFor!

header
	^header!

header: aHeader
	header := aHeader! !
!SixxMockEnvelope categoriesFor: #header!accessing!public! !
!SixxMockEnvelope categoriesFor: #header:!accessing!public! !

!SixxMockEnvelope class methodsFor!

header: aHeader
	super initialize.
	^self new header: aHeader! !
!SixxMockEnvelope class categoriesFor: #header:!instance creation!public! !

SixxMockHeader guid: (GUID fromString: '{D92516BD-62E0-4988-BDB0-19063E011F91}')!
SixxMockHeader comment: ''!
!SixxMockHeader categoriesForClass!Kernel-Objects! !
!SixxMockHeader methodsFor!

id
	^id!

id: aString
	id := aString! !
!SixxMockHeader categoriesFor: #id!accessing!public! !
!SixxMockHeader categoriesFor: #id:!accessing!public! !

!SixxMockHeader class methodsFor!

id: aString
	^self new id: aString! !
!SixxMockHeader class categoriesFor: #id:!instance creation!public! !

SixxMockSuperClassForUnitTest guid: (GUID fromString: '{96275E14-E840-43BE-A9A1-BF5D77A77B0A}')!
SixxMockSuperClassForUnitTest comment: ''!
!SixxMockSuperClassForUnitTest categoriesForClass!Kernel-Objects! !
!SixxMockSuperClassForUnitTest class methodsFor!

initialize
	"MockSuperClassForUnitTest initialize"

	super initialize.
	instVar1 := nil.
	instVar2 := nil!

instVar1
	instVar1 isNil ifTrue: [instVar1 := ''].
	^instVar1!

instVar1: aString
	instVar1 := aString!

instVar2
	instVar2 isNil ifTrue: [instVar2 := ''].
	^instVar2!

instVar2: aString
	instVar2 := aString! !
!SixxMockSuperClassForUnitTest class categoriesFor: #initialize!class initialization!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar1!accessing!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar1:!accessing!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar2!accessing!public! !
!SixxMockSuperClassForUnitTest class categoriesFor: #instVar2:!accessing!public! !

SixxMockClassForUnitTest guid: (GUID fromString: '{5FFA7827-0498-4AB9-BF1C-D28A4BA1CA1F}')!
SixxMockClassForUnitTest comment: ''!
!SixxMockClassForUnitTest categoriesForClass!Kernel-Objects! !
!SixxMockClassForUnitTest class methodsFor!

initialize
	"MockClassForUnitTest initialize"

	super initialize.
	instVar3 := nil!

instVar3
	instVar3 isNil ifTrue: [instVar3 := ''].
	^instVar3!

instVar3: aString
	instVar3 := aString! !
!SixxMockClassForUnitTest class categoriesFor: #initialize!accessing!class initialization!public! !
!SixxMockClassForUnitTest class categoriesFor: #instVar3!accessing!public! !
!SixxMockClassForUnitTest class categoriesFor: #instVar3:!accessing!public! !

SixxConstantsTestCase guid: (GUID fromString: '{B5C27D71-9720-4B0D-A826-9411E7A9CCEC}')!
SixxConstantsTestCase comment: ''!
!SixxConstantsTestCase categoriesForClass!SUnit! !
!SixxConstantsTestCase methodsFor!

oldSixxConstants
	^ oldSixxConstants!

oldSixxConstants: aSixxConstants
	oldSixxConstants := aSixxConstants!

setUp
	^self oldSixxConstants: SixxConstants!

tearDown
	SixxConstants initialize.
	SixxConstants xmlVersion: self oldSixxConstants xmlVersion.
	SixxConstants xmlEncoding: self oldSixxConstants xmlEncoding.
	SixxConstants sixxVersion: self oldSixxConstants sixxVersion!

testInitialize
	SixxConstants initialize.
	self should: [SixxConstants xmlVersion = '1.0'].
	self should: [SixxConstants xmlEncoding = 'utf-8'].
	self should: [SixxConstants sixxVersion = '1.0']!

testSixxStartTag
	SixxConstants initialize.
	self should: [SixxConstants sixxStartTag = '<sixx sixx.version="1.0">'].
	SixxConstants sixxVersion: '2.0'.
	self should: [SixxConstants sixxStartTag = '<sixx sixx.version="2.0">']!

testXmlDeclaration
	SixxConstants initialize.
	self should: [SixxConstants xmlDeclaration = '<?xml version="1.0" encoding="utf-8"?>'].
	SixxConstants xmlVersion: '3.0'.
	SixxConstants xmlEncoding: 'sjis'.
	self should: [SixxConstants xmlDeclaration = '<?xml version="3.0" encoding="sjis"?>']! !
!SixxConstantsTestCase categoriesFor: #oldSixxConstants!accessing!private! !
!SixxConstantsTestCase categoriesFor: #oldSixxConstants:!accessing!private! !
!SixxConstantsTestCase categoriesFor: #setUp!private!running! !
!SixxConstantsTestCase categoriesFor: #tearDown!private!running! !
!SixxConstantsTestCase categoriesFor: #testInitialize!public!tests! !
!SixxConstantsTestCase categoriesFor: #testSixxStartTag!public!tests! !
!SixxConstantsTestCase categoriesFor: #testXmlDeclaration!public!tests! !

SixxGeneratingTestCase guid: (GUID fromString: '{12F09600-F2E2-4783-BCD2-B3BEE9218957}')!
SixxGeneratingTestCase comment: ''!
!SixxGeneratingTestCase categoriesForClass!SUnit! !
!SixxGeneratingTestCase methodsFor!

testSixxStringForArrayObject
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Array new: 3.
	arr at: 1 put: 10.
	arr at: 2 put: 20.
	arr at: 3 put: 30.
	self should: [arr sixxString = expectedStr]!

testSixxStringForBagObject
	| bag result |
	bag := Bag new.
	bag add: 10.
	bag add: 20.
	bag add: 30.
	result := Object readSixxFrom: bag sixxString.
	self should: [result size = 3].
	self should: [result includes: 10].
	self should: [result includes: 20].
	self should: [result includes: 30]!

testSixxStringForBooleanObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self should: [true sixxString = expectedStr]!

testSixxStringForByteArrayObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="ByteArray" >#( 10 20 30 )</sixx.object>
'.
	self 
		should: [(ByteArray 
				with: 10
				with: 20
				with: 30) sixxString = expectedStr]!

testSixxStringForCharacterObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self should: [$A sixxString = expectedStr]!

testSixxStringForClassObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="String" >value1</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="String" >value2</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="String" >value3</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest instVar1: 'value1'.
	SixxMockClassForUnitTest instVar2: 'value2'.
	SixxMockClassForUnitTest instVar3: 'value3'.
	self should: [SixxMockClassForUnitTest sixxString = expectedStr]!

testSixxStringForCompositeDictionaryObject
	"SixxGeneratingTestCase debug: 
	#testSixxStringForCompositeDictionaryObject"

	| dic childDic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >parent2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >parent1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >sample string.</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >parent4</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="Dictionary" >
			<sixx.object sixx.id="10" sixx.type="Association" >
				<sixx.object sixx.id="11" sixx.name="key" sixx.type="Symbol" >child1</sixx.object>
				<sixx.object sixx.id="12" sixx.name="value" sixx.type="String" >abcde</sixx.object>
			</sixx.object>
		</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="13" sixx.type="Association" >
		<sixx.object sixx.id="14" sixx.name="key" sixx.type="Symbol" >parent3</sixx.object>
		<sixx.object sixx.id="15" sixx.name="value" sixx.type="Array" >
			<sixx.object sixx.id="16" sixx.type="SmallInteger" >10</sixx.object>
			<sixx.object sixx.id="17" sixx.type="SmallInteger" >20</sixx.object>
			<sixx.object sixx.id="18" sixx.type="SmallInteger" >30</sixx.object>
		</sixx.object>
	</sixx.object>
</sixx.object>
'.
	childDic := Dictionary new.
	childDic at: #child1 put: 'abcde'.
	dic := Dictionary new.
	dic at: #parent1 put: 'sample string.'.
	dic at: #parent2 put: 100.
	dic at: #parent3 put: #(10 20 30).
	dic at: #parent4 put: childDic.
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent1) 
				= ((Object readSixxFrom: expected) at: #parent1)].
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent2) 
				= ((Object readSixxFrom: expected) at: #parent2)].
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent3) 
				= ((Object readSixxFrom: expected) at: #parent3)].
	self should: 
			[((Object readSixxFrom: dic sixxString) at: #parent4) 
				equals: ((Object readSixxFrom: expected) at: #parent4)]!

testSixxStringForDateObject
	"SixxGeneratingTestCase debug: #testSixxStringForDateObject"

	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self should: 
			[(Date 
				newDay: 14
				monthNumber: 5
				year: 2002) sixxString = expectedStr]!

testSixxStringForDictionaryObject
	"SixxGeneratingTestCase debug: 
	#testSixxStringForDictionaryObject"

	| dic expected |
	expected := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="String" >value2</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.id="9" sixx.name="value" sixx.type="String" >value3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Dictionary new.
	dic at: #key1 put: 'value1'.
	dic at: #key2 put: 'value2'.
	dic at: #key3 put: 'value3'.
	self 
		should: [(Object readSixxFrom: dic sixxString) equals: (Object readSixxFrom: expected)]!

testSixxStringForIndexedColorObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="IndexedColor" >(IndexedColor stdColor: #blue)</sixx.object>
'.
	self should: [Color blue sixxString = expectedStr]!

testSixxStringForNumberObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Fraction" >(3/4)</sixx.object>
'.
	self should: [(3 / 4) sixxString = expectedStr]!

testSixxStringForOrdredCollectionObject
	| expectedStr col |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="OrderedCollection" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	col := OrderedCollection new.
	col add: 10.
	col add: 20.
	col add: 30.
	self should: [col sixxString = expectedStr]!

testSixxStringForRGBObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RGB" >(RGB red: 0 green: 0 blue: 255)</sixx.object>
'.
	self should: [RGB blue sixxString = expectedStr]!

testSixxStringForRunArrayObject
	| arr expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	arr := RunArray runs: #(1 2 1) values: #(1 2 3).
	self should: [arr sixxString = expectedStr]!

testSixxStringForSimpleObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Object" >
</sixx.object>
'.
	self should: [Object new sixxString = expectedStr]!

testSixxStringForStringObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="String" >Hi&#44; I&apos;m String-object</sixx.object>
'.
	self should: ['Hi, I''m String-object' sixxString = expectedStr]!

testSixxStringForTimeObject
	"SixxGeneratingTestCase debug:#testSixxStringForTimeObject"

	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="Time" >1:30:59 pm</sixx.object>
'.
	self should: [(Time sixxReadFrom: (ReadStream on: '1:30:59 pm')) sixxString = expectedStr]!

testSixxStringForUndefinedObject
	| expectedStr |
	expectedStr := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self should: [nil sixxString = expectedStr]! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForArrayObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForBagObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForBooleanObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForByteArrayObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForCharacterObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForClassObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForCompositeDictionaryObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForDateObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForDictionaryObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForIndexedColorObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForNumberObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForOrdredCollectionObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForRGBObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForRunArrayObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForSimpleObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForStringObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForTimeObject!public!tests! !
!SixxGeneratingTestCase categoriesFor: #testSixxStringForUndefinedObject!public!tests! !

SixxLoadingTestCase guid: (GUID fromString: '{EB302298-D3E5-4989-B80D-8E5BD16A056F}')!
SixxLoadingTestCase comment: ''!
!SixxLoadingTestCase categoriesForClass!SUnit! !
!SixxLoadingTestCase methodsFor!

testReadSixxForArrayObject
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self should: [arr size = 3].
	self should: [(arr at: 1) = 10].
	self should: [(arr at: 2) = 20].
	self should: [(arr at: 3) = 30]!

testReadSixxForBagObject
	| sixxString bag |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Bag" >
	<sixx.object sixx.id="1" sixx.type="String" >abcd</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.idref="2" ></sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
</sixx.object>
'.
	bag := Object readSixxFrom: sixxString.
	self should: [bag size = 4].
	self should: [(bag occurrencesOf: 10) = 2].
	self should: [(bag occurrencesOf: 'abcd') = 1].
	self should: [(bag occurrencesOf: #(10 20)) = 1]!

testReadSixxForBooleanObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="True" >true</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = true]!

testReadSixxForByteArrayObject
	| sixxString byteArr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="ByteArray" >#( 10 20 30 )</sixx.object>
'.
	byteArr := Object readSixxFrom: sixxString.
	self should: [byteArr size = 3].
	self should: [(byteArr at: 1) = 10].
	self should: [(byteArr at: 2) = 20].
	self should: [(byteArr at: 3) = 30]!

testReadSixxForCharacterObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Character" >$A</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = $A]!

testReadSixxForClassObject
	"SixxLoadingTestCase debug: #testReadSixxForClassObject"

	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockClassForUnitTest class" >
	<sixx.object sixx.id="1" sixx.name="instVar1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.name="instVar2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.id="3" sixx.name="instVar3" sixx.type="SmallInteger" >30</sixx.object>
</sixx.object>
'.
	SixxMockClassForUnitTest
		instVar1: 0;
		instVar2: 0;
		instVar3: 0.
	self should: [SixxMockClassForUnitTest instVar1 = 0].
	self should: [SixxMockClassForUnitTest instVar2 = 0].
	self should: [SixxMockClassForUnitTest instVar3 = 0].
	Object readSixxFrom: sixxString.
	self should: [SixxMockClassForUnitTest instVar1 = 10].
	self should: [SixxMockClassForUnitTest instVar2 = 20].
	self should: [SixxMockClassForUnitTest instVar3 = 30]!

testReadSixxForCompositeObject
	| sixxString slipObj headerObj |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockEnvelope" >
	<sixx.object sixx.id="1" sixx.name="header" sixx.type="SixxMockHeader" >
		<sixx.object sixx.id="2" sixx.name="id" sixx.type="String" >99</sixx.object>
	</sixx.object>
</sixx.object>
'.
	slipObj := Object readSixxFrom: sixxString.
	headerObj := slipObj header.
	self should: [headerObj id = '99']!

testReadSixxForDateObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Date" >14 May 2002</sixx.object>
'.
	self should: 
			[(Object readSixxFrom: sixxString) = (Date 
						newDay: 14
						monthIndex: 5
						year: 2002)]!

testReadSixxForDictionaryObject
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self should: [dic size = 2].
	self should: [(dic at: #key1) = 'value1'].
	self should: [(dic at: #key2) = 100]!

testReadSixxForIndexedColorObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="IndexedColor" >(IndexedColor stdColor: #red)</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = IndexedColor red]!

testReadSixxForRecursiveArrayObject
	| sixxString arr |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
	<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	arr := Object readSixxFrom: sixxString.
	self should: [arr size = 3].
	self should: [(arr at: 1) = 10].
	self should: [(arr at: 2) = 20].
	self should: [(arr at: 3) == arr]!

testReadSixxForRecursiveDictionaryObject
	| sixxString dic |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Dictionary" >
	<sixx.object sixx.id="1" sixx.type="Association" >
		<sixx.object sixx.id="2" sixx.name="key" sixx.type="Symbol" >key2</sixx.object>
		<sixx.object sixx.id="3" sixx.name="value" sixx.type="SmallInteger" >100</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="Association" >
		<sixx.object sixx.id="5" sixx.name="key" sixx.type="Symbol" >key1</sixx.object>
		<sixx.object sixx.id="6" sixx.name="value" sixx.type="String" >value1</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="7" sixx.type="Association" >
		<sixx.object sixx.id="8" sixx.name="key" sixx.type="Symbol" >key3</sixx.object>
		<sixx.object sixx.idref="0" sixx.name="value" ></sixx.object>
	</sixx.object>
</sixx.object>
'.
	dic := Object readSixxFrom: sixxString.
	self should: [dic size = 3].
	self should: [(dic at: #key1) = 'value1'].
	self should: [(dic at: #key2) = 100].
	self should: [(dic at: #key3) == dic]!

testReadSixxForRGBObject
	"SixxLoadingTestCase debug: #testReadSixxForRGBObject"

	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RGB" >(RGB red: 0 green: 0 blue: 255)</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = RGB blue]!

testReadSixxForRunArrayObject
	| sixxString runArray |
	sixxString := '<sixx.object sixx.id="0" sixx.type="RunArray" >
	<sixx.object sixx.id="1" sixx.name="runs" sixx.type="Array" >
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >1</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >2</sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.name="values" sixx.type="Array" >
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >3</sixx.object>
	</sixx.object>
</sixx.object>
'.
	runArray := Object readSixxFrom: sixxString.
	self should: [runArray runs = #(1 2 1)].
	self should: [runArray values = #(1 2 3)]!

testReadSixxForSimpleObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="SixxMockHeader" >
	<sixx.object sixx.id="1" sixx.name="id" sixx.type="String" >1000</sixx.object>
</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) id = '1000']!

testReadSixxForTimeObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Time" >4:10:32 pm</sixx.object>
'.
	self 
		should: [(Object readSixxFrom: sixxString) = (Time sixxReadFrom: (ReadStream on: '4:10:32 pm'))]!

testReadSixxForUndefinedObject
	| sixxString |
	sixxString := '<sixx.object sixx.id="0" sixx.type="UndefinedObject" >nil</sixx.object>
'.
	self should: [(Object readSixxFrom: sixxString) = nil]!

testReadSixxWithClassDoesNotExist
	"SixxLoadingTestCase debug: #testReadSixxWithClassDoesNotExist"

	| str catched |
	str := '<sixx.object sixx.id="0" sixx.type="doesNotExistString" >abcde</sixx.object>
'.
	self should: [(Object readSixxFrom: str) = nil].
	catched := false.
	self should: 
			[[Object readSixxFrom: str] on: SixxClassNotFound do: [:ex | catched := true].
			catched]! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForArrayObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForBagObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForBooleanObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForByteArrayObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForCharacterObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForClassObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForCompositeObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForDateObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForDictionaryObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForIndexedColorObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRecursiveArrayObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRecursiveDictionaryObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRGBObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForRunArrayObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForSimpleObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForTimeObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxForUndefinedObject!public!tests! !
!SixxLoadingTestCase categoriesFor: #testReadSixxWithClassDoesNotExist!public!tests! !

SixxReadStreamTestCase guid: (GUID fromString: '{52E390D4-E836-4864-B0D6-303D3FB709F4}')!
SixxReadStreamTestCase comment: ''!
!SixxReadStreamTestCase categoriesForClass!SUnit! !
!SixxReadStreamTestCase methodsFor!

testAtEnd
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream next = 'a' and: [stream atEnd not]].
	self should: [stream next = 'b' and: [stream atEnd not]].
	self should: [stream next = 'c' and: [stream atEnd]].
	self should: [stream next = nil and: [stream atEnd]]!

testCachedObjects
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	stream
		next;
		next.
	self should: [(stream cachedObjects at: 1) = 'a'].
	self should: [(stream cachedObjects at: 2) = 'b'].
	self shouldnt: [stream cachedObjects includesKey: 3].
	stream next.
	self should: [(stream cachedObjects at: 3) = 'c']!

testNext
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream next = 'a'].
	self should: [stream next = 'b'].
	self should: [stream next = 'c'].
	self should: [stream next = nil]!

testNextMany
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [(stream next: 2) = (OrderedCollection with: 'a' with: 'b')].
	stream reset.
	self should: 
			[(stream next: 5) = (OrderedCollection 
						with: 'a'
						with: 'b'
						with: 'c')]!

testNextWithIdred
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$u</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
	<sixx.object sixx.idref="1" ></sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream next = $a].
	self should: [stream next = $u].
	self should: [stream next = $a].
	self should: [stream next = $u]!

testPeek
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream position = 0].
	self should: [stream peek = 'a'].
	self should: [stream position = 0].
	self should: [stream next = 'a']!

testPosition
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	stream next: 3.
	self should: [stream position = 3].
	stream position: 1.
	self should: [stream next = 'b']!

testReadNextContainsIdref
	| str stream firstObj secondObj thirdObj |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream size = 3].
	firstObj := stream next.
	secondObj := stream next.
	thirdObj := stream next.
	self should: [firstObj = #(10 20 30)].
	self should: [(secondObj at: 1) == firstObj].
	self should: [thirdObj = #(10 20 30) and: [thirdObj ~~ firstObj]]!

testReset
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	[stream atEnd] whileFalse: [stream next].
	self should: [stream next = nil].
	stream reset.
	self should: [stream position = 0]!

testSize
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: str readStream.
	self should: [stream size = 3]!

testSkip
	| str stream |
	str := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="String" >b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >c</sixx.object>
</sixx>'.
	stream := SixxReadStream on: (ReadStream on: str).
	self should: [stream position = 0].
	stream skip: 1.
	self should: [stream position = 1].
	stream next.
	self should: [stream position = 2].
	stream skip: 1.
	self should: [stream position = 3].
	stream skip: -1.
	self should: [stream position = 2].
	stream skip: 2.
	self should: [stream position = 3]! !
!SixxReadStreamTestCase categoriesFor: #testAtEnd!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testCachedObjects!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testNext!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testNextMany!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testNextWithIdred!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testPeek!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testPosition!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testReadNextContainsIdref!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testReset!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testSize!public!tests! !
!SixxReadStreamTestCase categoriesFor: #testSkip!public!tests! !

SixxWriteStreamTestCase guid: (GUID fromString: '{78B46238-085E-466E-89A8-B4292596987A}')!
SixxWriteStreamTestCase comment: ''!
!SixxWriteStreamTestCase categoriesForClass!SUnit! !
!SixxWriteStreamTestCase methodsFor!

testCloseTwice
	"SixxWriteStreamTestCase debug: #testCloseTwice"

	| st wst expected |
	expected := 
'<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	wst close.
	self should: [st contents = expected]!

testKeepStreamOpening
	"SixxWriteStreamTestCase debug: #testKeepStreamOpening"

	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	self should: [st contents = expected]!

testNeverNextPutAndThenClose
	| st wst expected |
	expected := ''.
	st := WriteStream on: String new.
	wst := SixxWriteStream on: st.
	wst close.
	self should: [st contents = expected]!

testNextPut
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="String" >abc</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: 'abc'.
	wst close.
	self should: [st contents = expected]!

testNextPutAll
	| st wst expected |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Character" >$a</sixx.object>
	<sixx.object sixx.id="1" sixx.type="Character" >$b</sixx.object>
	<sixx.object sixx.id="2" sixx.type="Character" >$c</sixx.object>
</sixx>'.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPutAll: 'abc'.
	wst close.
	self should: [st contents = expected]!

testWriteRecursiveObject
	| st wst expected arr col |
	expected := '<?xml version="1.0" encoding="utf-8"?>
<sixx sixx.version="1.0">
	<sixx.object sixx.id="0" sixx.type="Array" >
		<sixx.object sixx.id="1" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="2" sixx.type="SmallInteger" >20</sixx.object>
		<sixx.object sixx.id="3" sixx.type="SmallInteger" >30</sixx.object>
	</sixx.object>
	<sixx.object sixx.id="4" sixx.type="OrderedCollection" >
		<sixx.object sixx.idref="0" ></sixx.object>
	</sixx.object>
	<sixx.object sixx.id="5" sixx.type="Array" >
		<sixx.object sixx.idref="1" ></sixx.object>
		<sixx.object sixx.idref="2" ></sixx.object>
		<sixx.object sixx.idref="3" ></sixx.object>
	</sixx.object>
</sixx>'.
	arr := #(10 20 30).
	col := OrderedCollection with: arr.
	st := WriteStream on: String new.
	wst := SixxWriteStream onWithDeclaration: st.
	wst nextPut: arr.
	wst nextPut: col.
	wst nextPut: #(10 20 30) copy.
	wst close.
	self should: [st contents = expected]! !
!SixxWriteStreamTestCase categoriesFor: #testCloseTwice!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testKeepStreamOpening!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testNeverNextPutAndThenClose!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testNextPut!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testNextPutAll!public!tests! !
!SixxWriteStreamTestCase categoriesFor: #testWriteRecursiveObject!public!tests! !

SixxXmlParserTestCase guid: (GUID fromString: '{1D781716-BB76-44E4-82AB-AFE8C8ED627C}')!
SixxXmlParserTestCase comment: ''!
!SixxXmlParserTestCase categoriesForClass!SUnit! !
!SixxXmlParserTestCase methodsFor!

testParseXmlWithSixxYaxoXmlParserAdapter
	"SixxXmlParserTestCase debug: #testParseXmlWithSixxYaxoXmlParserAdapter"

	| sixxString result oldParser |
	sixxString := '<sixx.object sixx.id="0" sixx.type="Array" >
	<sixx.object sixx.id="1" sixx.type="SmallInteger" >100</sixx.object>
	<sixx.object sixx.id="2" sixx.type="String" >abcde</sixx.object>
	<sixx.object sixx.id="3" sixx.type="Array" >
		<sixx.object sixx.id="4" sixx.type="SmallInteger" >10</sixx.object>
		<sixx.object sixx.id="5" sixx.type="SmallInteger" >20</sixx.object>
	</sixx.object>
	<sixx.object sixx.idref="0" ></sixx.object>
</sixx.object>
'.
	oldParser := SixxXmlUtil parserAdapter.
	
	[SixxXmlUtil parserAdapter: SixxYaxoXmlParserAdapter.
	result := Object readSixxFrom: sixxString.
	self should: [(result at: 1) = 100].
	self should: [(result at: 2) = 'abcde'].
	self should: [(result at: 3) = #(10 20)].
	self should: [(result at: 4) == result]] 
			ensure: [SixxXmlUtil parserAdapter: oldParser]! !
!SixxXmlParserTestCase categoriesFor: #testParseXmlWithSixxYaxoXmlParserAdapter!public!tests! !

"Binary Globals"!

"Resources"!

