| package |
package := Package name: 'SIXX-ParserAdapter'.
package paxVersion: 0;
	basicComment: ''.


package classNames
	add: #SixxXmlParserAdapter;
	add: #SixxYaxoXmlParserAdapter;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package allResourceNames: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\Steve Waring\Yaxo\YAXO DOM';
	yourself).

package!

"Class Definitions"!

Object subclass: #SixxXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SixxXmlParserAdapter subclass: #SixxYaxoXmlParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SixxXmlParserAdapter guid: (GUID fromString: '{D6A1B1AE-D084-4924-9C3D-ABE91A9843C3}')!
SixxXmlParserAdapter comment: ''!
!SixxXmlParserAdapter categoriesForClass!Kernel-Objects! !
!SixxXmlParserAdapter class methodsFor!

attributeAt: attributeName from: sixxElement
	self subclassResponsibility!

characterDataFrom: sixxElement
	self subclassResponsibility!

elementsFrom: sixxElement
	self subclassResponsibility!

isTextFrom: sixxElement
	^sixxElement isText!

nameFrom: sixxElement
	self subclassResponsibility!

parseXml: xmlStringOrStream
	self subclassResponsibility! !
!SixxXmlParserAdapter class categoriesFor: #attributeAt:from:!aceions/parse!public! !
!SixxXmlParserAdapter class categoriesFor: #characterDataFrom:!aceions/parse!public! !
!SixxXmlParserAdapter class categoriesFor: #elementsFrom:!aceions/parse!public! !
!SixxXmlParserAdapter class categoriesFor: #isTextFrom:!aceions/parse!public! !
!SixxXmlParserAdapter class categoriesFor: #nameFrom:!aceions/parse!public! !
!SixxXmlParserAdapter class categoriesFor: #parseXml:!actions!public! !

SixxYaxoXmlParserAdapter guid: (GUID fromString: '{D5CC3FAE-7963-4586-8652-43F6008990A1}')!
SixxYaxoXmlParserAdapter comment: ''!
!SixxYaxoXmlParserAdapter categoriesForClass!Kernel-Objects! !
!SixxYaxoXmlParserAdapter class methodsFor!

attributeAt: attributeName from: sixxElement
	^sixxElement attributeAt: attributeName!

characterDataFrom: sixxElement
	^sixxElement contentString!

elementsFrom: sixxElement
	^sixxElement elements!

nameFrom: sixxElement
	^sixxElement name!

parseXml: xmlStringOrStream
	| stream |
	stream := xmlStringOrStream isString 
				ifFalse: [xmlStringOrStream]
				ifTrue: [ReadStream on: xmlStringOrStream].
	^(XMLDOMParser parseDocumentFrom: stream) topElement
! !
!SixxYaxoXmlParserAdapter class categoriesFor: #attributeAt:from:!aceions/parse!public! !
!SixxYaxoXmlParserAdapter class categoriesFor: #characterDataFrom:!aceions/parse!public! !
!SixxYaxoXmlParserAdapter class categoriesFor: #elementsFrom:!aceions/parse!public! !
!SixxYaxoXmlParserAdapter class categoriesFor: #nameFrom:!aceions/parse!public! !
!SixxYaxoXmlParserAdapter class categoriesFor: #parseXml:!aceions/parse!public! !

"Binary Globals"!

"Resources"!

